unit ldn148fetch_html_u1;

(*As it stands...

This is a "bare bones" demo of the BASICS of fetching "stuff" via HTTP.

It is the code discussed at...
  http://wywtk.com/lut/ldn148httpfetch/ldn148.htm

Normally, of course, the "stuff" would consist of HTML. But there's
  nothing about HTTP that stops it transfering any file that someone
  has put on an HTTP server.

The "stuff" is fetched in its "raw" from. The HTML is not interpreted,
  you just get the text behind what a browser would interpret.

Besides THIS code... which is reasonably "correct", and "complete" (as
  far as it goes), I also offer a .zip with the whole of something a
  little more "real world". (Complete with the rough edges and
  uncertainties of the real world.) The zip contains the whole Lazarus
  project, i.e. the sourcecode, and a compiled .exe so you can see it
  in action without the hassle of compiling the sourcecode.

  That is at...
      https://wywtk.com/lut/zips/ldn147fetch_html_w_err_codes.zip

  (The zip THIS sourcecode is in can be found at...
      https://wywtk.com/lut/zips/ldn148fetch_html.zip

  NOTE: "148" is OLDER (and less extensive) that "147"... they are
     "numbered" "backwards, you might say.)

  1//////
  THIS CANNOT FETCH AN httpS page.
  But there ARE ways to do that!...
  See...
  https://forum.lazarus.freepascal.org/index.php?topic=42929.0
  ... and...
  https://wiki.freepascal.org/Synapse#SSL.2FTLS_support

  2//////
  Important bit to do next....
     This reports "success" or "failure".
     That MAY be all that the nice, simple, TTPGetText offers.
     But!
     Either somehow with that, or by using a differnt
       Synapse routine, the NATURE of the failure is available.
       Find. Implement. ("Nature of error"- e.g. "404 error")

    See...
    https://wiki.freepascal.org/Synapse#Advanced_version
    ... where error codes ARE collected.

    ---
    "Absence of evidence is not evidence of absence"...
    ... but SO FAR I've found no hint that httpGetText
    gives the user anything more that "succeeded" or
    "didn't" when called. (That, and the text, of course.)
    -- It may well be that httpGetText is a "simple" function,
    great for what it can do, but not able to "do everything".
    It is NOT the only way to fetch a page via HTTP.
    Perhaps I need to rewrite this, using a different basis,
    if I want the messages about WHY no page fetched?

  3//////
  A frill that would be nice: Pressing the Enter key when
    eURL has focus should trigger a fetch.
    This is probably "easy" to implement... if you know how!
    (Just needs one of eURLs to make a call to DoFetchPage,
    I imagine. But which event!)
*)

{$mode objfpc}{$H+}

interface

//To compile this code, you must first install Synapse on your system.
//See http://sheepdogguides.com/lut/lt5Nb.htm

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  httpsend, //httpsend added by hand, so Synapse could be used
  ssl_openssl; //ssl_openssl added by hand, so Synapse could be used
type

  { Tldn148fetch_html_f1 }

  Tldn148fetch_html_f1 = class(TForm)
    buFetch: TButton;
    eURL: TEdit;
    laTxtNoHTTPS2: TLabel;
    laTxtNoHTTPS: TLabel;
    laTxtErrorReport: TLabel;
    laErrorReport: TLabel;
    laTxtNoHTTPS3: TLabel;
    meDisplayPage: TMemo;
    buQuit: TToggleBox;
    procedure buFetchClick(Sender: TObject);
    procedure buQuitChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    sTmp:string;
    function FetchFillReturnErrorCode:boolean;
    procedure DoFetchPage;
  public

  end;

var
  ldn148fetch_html_f1: Tldn148fetch_html_f1;

const vers='17 Jul 2022, 19:00';

implementation

{$R *.lfm}

{ Tldn148fetch_html_f1 }

function Tldn148fetch_html_f1.FetchFillReturnErrorCode:boolean;
var boErrL:boolean;
begin
 boErrL:=HTTPGetText(eURL.text,meDisplayPage.lines);
 result:=boErrL;
end;

procedure Tldn148fetch_html_f1.buQuitChange(Sender: TObject);
begin
  close;//NOT "app...terminate". ("close" is ini file friendly)
end;

procedure Tldn148fetch_html_f1.FormCreate(Sender: TObject);
begin
  laErrorReport.caption:='----';
  application.title:='';
  ldn148fetch_html_f1.caption:='LDN148- Simple HTML fetch. Vers: '+vers;
end;

procedure Tldn148fetch_html_f1.buFetchClick(Sender: TObject);
//For help, see  http://synapse.ararat.cz/doc/help/httpsend.html#HttpGetText
begin
  DoFetchPage;
end;

procedure Tldn148fetch_html_f1.DoFetchPage;
var boTmpL:boolean;
begin
  boTmpL:=FetchFillReturnErrorCode;
  sTmp:='Fetch failed';
  if boTmpL then sTmp:='Success';
  laErrorReport.caption:=sTmp
end;

end.

